#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <net/ethernet.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>
#include <linux/sockios.h>
#include <net/if.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <sys/time.h>
#include <unistd.h>
#include <signal.h>

#define MAX_PACKET_SIZE 1514
#define MAX_INTERFACE 5
#define TIMER_SIGALARM 5
#define MAX_RIGHE_SCRIVIBILI 25

struct sockaddr_ll fromaddr;
struct ifreq ifq;
int fd,fromlen,br,br_tot[MAX_INTERFACE],continua,scrivi;
char buf[MAX_PACKET_SIZE],interface_name[16],int_ind[MAX_INTERFACE][16];

scrivi_file(void)
 {
  FILE *fp;
  char dir[150],dire[]="/var/log/yaiptraf/";
  int contatore,righe=MAX_RIGHE_SCRIVIBILI-1;
 
  scrivi=0;
  for (contatore=0; contatore<MAX_INTERFACE; contatore++)
   {
    if (*int_ind[contatore]!=0)
     {
      sprintf(dir, "cat %s%s | tail -%d > %s%s",dire,int_ind[contatore],righe,dire,int_ind[contatore]);
      fp=popen(dir, "w");
      pclose(fp);
      sprintf(dir, "%s%s",dire,int_ind[contatore]);
      fp=fopen(dir, "a+");
      fprintf(fp, "%d %d\n",br_tot[contatore],TIMER_SIGALARM);
      fclose(fp);
      br_tot[contatore]=0;
      br=0;
     }
   }
 }

somma_pacchetti(void)
 {
  int contatore,trovato;

  trovato=-1;
  /* controlla se l'interfaccia  presente nell'int_ind */
  for (contatore=0; contatore<MAX_INTERFACE; contatore++)
   {
    if (strcmp(interface_name, int_ind[contatore])==0)
     {
      trovato=contatore;
     }
   }
  if (trovato==-1)
   {
    for (contatore=0; (contatore<MAX_INTERFACE && trovato==-1); contatore++)
     {
      if (! *int_ind[contatore])
       {
        trovato=contatore;
        strcpy(int_ind[contatore], interface_name);
       }
     }
   }
  br_tot[trovato]=br_tot[trovato]+br;
  br=0;
 }

ricevi_pacchetti(void)
 {
  continua=1;
  scrivi=0;
  fd = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_ALL));
  while(continua==1)
   {
    fromlen = sizeof(struct sockaddr_pkt);
    br=recvfrom(fd, buf, MAX_PACKET_SIZE, 0,(struct sockaddr *) &fromaddr, &fromlen);
    ifq.ifr_ifindex = fromaddr.sll_ifindex;
    ioctl (fd, SIOCGIFNAME, &ifq);
    strcpy(interface_name, ifq.ifr_name);
    if (scrivi==0)
     {
      somma_pacchetti();
     }
    else
     {
      scrivi_file();
     }
   }
  close(fd);
 }

file_trap(signo)
int signo;
 {
  alarm(TIMER_SIGALARM);
  scrivi=1;
 }

ctl_trap(signo)
int signo;
 {
  continua=0;
 }

main()
 {
  sigset(SIGINT, ctl_trap);
  sigset(SIGALRM, file_trap);
  alarm(TIMER_SIGALARM);
  ricevi_pacchetti();
 }
